cc For 3D version
      SUBROUTINE DATA(A,NMTE,ECON,T,NN,X,Y,Z
     + ,IFOR,FB,IDIS,UB,NGNG,NOM,IECON,NEUS,NNUS,NKIND,nstep)
      INCLUDE 'para.inc'
      INCLUDE 'const.inc'
      DIMENSION NMTE(*),NN(INMTE,*),X(*),Y(*),Z(*),IFOR(*),IDIS(*)
     +    ,FB(*),UB(*),NOM(*),ECON(9,*),NGNG(*),IECON(*)
      DIMENSION NEUS(*),NNUS(*),NKIND(*)
      OPEN(1,FILE='input.dat')
C     CHARACTER *1 A(72)
C     READ(5,1)A
C     1 FORMAT(72A1)
C     WRITE(6,1)A
c************************************************
      read(1,*)nstep            ! total # of increment
c************************************************
      READ(1,*)NGAUSS
c MNUM : kind of materials
      READ(1,*)MNUM
C+++++++++++++++++++++++++++++++++++++
      write(77,*)'DATA CHECK'
      write(77,*)'Total # of increment',nstep   ! added 
      write(77,*)'NUMBER OF MATERIAL =   ',MNUM
      write(77,*)'INTEGRATION ORDER =    ',NGAUSS
C+++++++++++++++++++++++++++++++++++++
C     READ(1,*)NPARA,T,MNUM
C--ANALYSIS CONDITION------------
C NPARA=0 --> PLANE STRESS
C NPARA=1 --> PLANE STRAIN
C NPARA=2 --> AXIAL SYMMETRY
C--------------------------------
C*ELASTIC CONSTANTS 
C  IECON = 1 --> ISOTROPIC
C    ECON(1,L)=YOUNG MODULE , ECON(2,L)=POISSON RATIO
C  IECON = 2 --> ANISOTROPIC
C    ECON(1,L)=C11 ECON(2,L)=C22 ECON(3,L)=C33 ECON(4,L)=C44 
C    ECON(5,L)=C55 ECON(6,L)=C66 ECON(7,L)=C12 ECON(8,L)=C13 
C    ECON(9,L)=C23  12->4 13->5 23->6
C
      DO 5 L=1,MNUM
	 READ(1,*)IECON(L)
         IEC = IECON(L)
	 IF (IEC.EQ.1)  THEN
            READ(1,*)MN,ECON(1,L),ECON(2,L),ECON(3,L)   !econ(3,l) is added
C+++++++++++++++++++++++++++++++++++++
          write(77,*)'Material',L
          write(77,*)'YOUNG=',ECON(1,L),', POISSON=',ECON(2,L), 
     +                                      'Yield stress=',ECON(3,L)  ! Yield stress
C+++++++++++++++++++++++++++++++++++++
         ELSE
	 IF (IEC.EQ.2)  THEN
            stop ! only isotropic version for Elasto-Plastic analysis
           READ(1,*)MN,ECON(1,L),ECON(2,L),ECON(3,L)
     +                ,ECON(4,L),ECON(5,L),ECON(6,L)
     +                ,ECON(7,L),ECON(8,L),ECON(9,L)
C+++++++++++++++++++++++++++++++++++++
          write(77,*)'Material',L
      write(77,*)'C11=',ECON(1,L),', C22=',ECON(2,L),', C33=',ECON(3,L)
      write(77,*)'C44=',ECON(4,L),', C55=',ECON(5,L),', C66=',ECON(6,L)
      write(77,*)'C12=',ECON(7,L),', C13=',ECON(8,L),', C23=',ECON(9,L)
         ENDIF
         ENDIF
 5    CONTINUE
      READ(1,*)NTN,NTE
c--------------------------------------
c NTN : NUMBER OF NODE
c NTE : NUMBER OF ELEMENT
c NTF : NUMBER OF FREEDOM
c NNA : NUMBER OF INTEGRATION POINT
c--------------------------------------
      NTF=NTN*IDIM
C+++++++++++++++++++++++++++++++++++++++++
      write(77,*)'TOTAL NODES    =   ',NTN
      write(77,*)'TOTAL ELEMENTS =   ',NTE
      write(77,*)'TOTAL FREEDOMS =   ',NTF
C+++++++++++++++++++++++++++++++++++++++++
      NNA=0
      DO 20 IE=1,NTE
         READ(1,*)II,NOM(IE),NMTE(IE),NKIND(IE)
c         READ(1,*)II,NOM(IE),NMTE(IE)
c*SORT IE : PROGRAM ELEMENT NUMBER , NEUS(IE) : USER ELEMENT
         NEUS(IE)=II
c---- 6 nodes sankaku-tyu
         IF(NMTE(IE).EQ.6) THEN
          IF (NGAUSS.EQ.1) NGNG(IE)=2
          IF (NGAUSS.EQ.2) NGNG(IE)=6
           READ(1,*)NN(1,IE),NN(2,IE),NN(3,IE),NN(4,IE),
     +              NN(5,IE),NN(6,IE)
C++++++++++++++++++++++++++++++++++++++++
          write(77,*)'ELEMENT',IE,':  MATERIAL',NOM(IE)
     +                                ,' : 6 NODES sankaku-tyuu'
C+++++++++++++++++++++++++++++++++++++++++
c---- 15 nodes sankaku-tyu
         ELSE IF(NMTE(IE).EQ.15) THEN
           READ(1,*)NN(1,IE),NN(2,IE),NN(3,IE),NN(4,IE),
     +              NN(5,IE),NN(6,IE),NN(7,IE),NN(8,IE), 
     +              NN(9,IE),NN(10,IE),NN(11,IE),NN(12,IE), 
     +              NN(13,IE),NN(14,IE),NN(15,IE) 
c******* NGAUSS= 2 or 3
          IF (NGAUSS.EQ.2) NGNG(IE)=6
          IF (NGAUSS.EQ.3) NGNG(IE)=12             
C++++++++++++++++++++++++++++++++++++++++
          write(77,*)'ELEMENT',IE,':  MATERIAL',NOM(IE)
     +                      ,' : 15 NODES sankaku-tyuu'
C+++++++++++++++++++++++++++++++++++++++++
c---- 8 nodes 8-men-tai
         ELSE IF(NMTE(IE).EQ.8) THEN
           READ(1,*)NN(1,IE),NN(2,IE),NN(3,IE),NN(4,IE),
     +              NN(5,IE),NN(6,IE),NN(7,IE),NN(8,IE) 
c******* NGAUSS= 2 or 3
           NGNG(IE)=NGAUSS*NGAUSS*NGAUSS
C++++++++++++++++++++++++++++++++++++++++
          write(77,*)'ELEMENT',IE,':  MATERIAL',NOM(IE)
     +                               ,' : 8 NODES 8-mentai'
C+++++++++++++++++++++++++++++++++++++++++
c---- 20 nodes 8-men-tai
         ELSE IF(NMTE(IE).EQ.20) THEN
           READ(1,*)NN(1,IE),NN(2,IE),NN(3,IE),NN(4,IE),
     +              NN(5,IE),NN(6,IE),NN(7,IE),NN(8,IE),
     +              NN(9,IE),NN(10,IE),NN(11,IE),NN(12,IE), 
     +              NN(13,IE),NN(14,IE),NN(15,IE),NN(16,IE),
     +              NN(17,IE),NN(18,IE),NN(19,IE),NN(20,IE)  
c******* NGAUSS= 2 or 3
           NGNG(IE)=NGAUSS*NGAUSS*NGAUSS 
C+++++++++++++++++++++++++++++++++++++++++         
          write(77,*)'ELEMENT',IE,':  MATERIAL',NOM(IE)
     +                               ,' : 20 NODES 8-mentai'
C+++++++++++++++++++++++++++++++++++++++++         
         ENDIF
         NNA=NNA+NGNG(IE)
 20   CONTINUE
C+++++++++++++++++++++++++++++++++++++++++
        write(77,*)'TOTAL INT.POINTS =   ',NNA
        write(77,*)'COORDINATE OF NODES'
        write(77,*)'PRO.NUM. , USR NUM. ,COORDINATION OF NODE'
C+++++++++++++++++++++++++++++++++++++++++         
      DO 40 I=1,NTN
         READ(1,*)JJ,X(I),Y(I),Z(I)
         write(77,112)I,JJ,X(I),Y(I),Z(I)
C*SORT I : PROGRAM NODE NUMBER , NNUS(I) : USER NODE NUMBER
         NNUS(I)=JJ
 40   CONTINUE
C+++++++++++++++++++++++++++++++++++++++++
 112  format(2(I4,x),3e15.7)
c      
      WRITE(77,*)'*ELEMENT NODE IS RECONSTRUCTED'
c
      DO 200 IE=1,NTE
        NMIE=NMTE(IE)
        WRITE(77,*)'USER   ',(NN(J3,IE),J3=1,NMIE)
c
       DO 210 J2 = 1,NMIE
        NNJ2 = NN(J2,IE)
        DO 220 I2 = 1,NTN
           KK = NNUS(I2)
           IF ( KK.EQ.NNJ2 ) THEN
            NN(J2,IE) = I2
           GO TO 210
           ENDIF
 220    CONTINUE
          WRITE(6,*)'NO MATCH'
          STOP
 210    CONTINUE
        WRITE(77,*)'PROGRAM',(NN(J3,IE),J3=1,NMIE)
 200    CONTINUE
c
      WRITE(77,*)'*FORCE BOUNDARY'
c
      READ(1,*)NTFOR
      IF(NTFOR.LT.1) GO TO 51
      DO 50 I=1,NTFOR
         READ(1,*)IFO,IXY,FF
c  IFO(USER NODE NUMBER) --> IFOP(PROGRAM NODE NUMBER)
         DO 55 I2 = 1,NTN
           KK=NNUS(I2)            
         IF ( KK.EQ.IFO ) THEN
           IFOP=I2
           GO TO 56
         ENDIF
 55      CONTINUE
            WRITE(77,*)'INVALID BOUNDARY CONDITION!(NO NODE)'
            WRITE(6,*)'ERROR!!'
            STOP
 56      CONTINUE
c         WRITE(6,*)IFO,IFOP
c------------------------------------------
         IF (IXY.GT.IDIM) THEN
            WRITE(77,*)'INVALID BOUNDARY CONDITION!(IXY.GT.IDIM)'
            WRITE(6,*)'ERROR'
            GO TO 51
         ENDIF
         NFREE = (IFOP-1)*IDIM + IXY
          IFOR(I)=NFREE
          FB(I) = FF
          IF (IXY.EQ.1) WRITE(77,*)'NODE',IFO,'-->FX=',FB(I),NFREE
          IF (IXY.EQ.2) WRITE(77,*)'NODE',IFO,'-->FY=',FB(I),NFREE
          IF (IXY.EQ.3) WRITE(77,*)'NODE',IFO,'-->FZ=',FB(I),NFREE
c
 50   CONTINUE
 51   CONTINUE
c
      WRITE(77,*)'*DISPLACEMENT BOUNDARY'
      READ(1,*)NTDIS
      IF(NTDIS.LT.1) GO TO 61
      DO 60 I=1,NTDIS
         READ(1,*)IDI,IXY,UU
         if (abs(uu).gt.1.0E-9) stop 'data' ! constrained displcement BC is not supported
c  IDI(USER NODE NUMBER) --> IDIP(PROGRAM NODE NUMBER)
         DO 65 I2 = 1,NTN
           KK=NNUS(I2)            
         IF ( KK.EQ.IDI ) THEN
           IDIP=I2
           GO TO 66
         ENDIF
 65      CONTINUE
            WRITE(77,*)'INVALID BOUNDARY CONDITION!(NO NODE)'
            WRITE(6,*)'ERROR!!'
            STOP
 66      CONTINUE
c         WRITE(6,*)IDI,IDIP
c------------------------------------------
         IF (IXY.GT.IDIM) THEN
            WRITE(77,*)'INVALID BOUNDARY CONDITION!(IXY.GT.IDIM)'
            WRITE(6,*)'ERROR'
            GO TO 61
         ENDIF
         NFREE = (IDIP-1)*IDIM + IXY
          IDIS(I)=NFREE
          UB(I) = UU
          IF (IXY.EQ.1) WRITE(77,*)'NODE',IDI,'-->UX=',UB(I)
     &                              ,'FREEDOM=',NFREE
          IF (IXY.EQ.2) WRITE(77,*)'NODE',IDI,'-->UY=',UB(I)
     &                              ,'FREEDOM=',NFREE
          IF (IXY.EQ.3) WRITE(77,*)'NODE',IDI,'-->UZ=',UB(I)
     &                              ,'FREEDOM=',NFREE
 60   CONTINUE
 61   CONTINUE
c
cccc FOR EQUATION
c  NAEQ : NUMBER OF EQUATION
c     NEQB : ROOT FREEDOM
c     NTEQ : NUMBER OF COPY FREEDOM
c     NEQ  : COPY FREEDOM
c
      READ(1,*)NAEQ
      IF (NAEQ.EQ.0) goto 88
      DO 80 I = 1,NAEQ
      READ(1,*)NEQB(I),NTEQ(I)
      READ(1,*)(NEQ(I,J),J=1,NTEQ(I))
 80   CONTINUE
 88   CONTINUE
      CLOSE(1)
c      
      RETURN
      END
