      SUBROUTINE INT(XI,ETA,ZETA,N,DNDXI,DNDETA,DNDZETA,
     +               NIF,DXIF,DETIF,DZEIF,NMTE,NN,NKIND)
      INCLUDE 'para.inc'
      INCLUDE 'const.inc'
      DIMENSION DNDXI(*),DNDETA(*),DNDZETA(*)
      DIMENSION NMTE(*),NN(INMTE,*),NKIND(*)
      DIMENSION DXIF(*),DETIF(*),DZEIF(*)
      DOUBLE PRECISION NIF(*)
c      DIMENSION DNDXI(*),DNDETA(*),DNDZETA(*),NMTE(*),NN(INMTE,*)
      DOUBLE PRECISION N(*)
c      
      NIE = NMTE(IE)
c
ccc sankaku-tyuu(liner element 6nodes)
      IF(NIE.EQ.6) THEN
      RD = 1.0 - XI - ETA
      A0 = (1.0-ZETA)/2.0
      B0 = (1.0+ZETA)/2.0
c <N>     
      N(1)= RD  * A0
      N(2)= XI  * A0
      N(3)= ETA * A0 
      N(4)= RD  * B0
      N(5)= XI  * B0
      N(6)= ETA * B0
c <dN/dXI>     
      DNDXI(1)= -A0
      DNDXI(2)=  A0
      DNDXI(3)=  0.0 
      DNDXI(4)= -B0
      DNDXI(5)=  B0 
      DNDXI(6)=  0.0
c <dN/dETA>     
      DNDETA(1)= -A0 
      DNDETA(2)= 0.0
      DNDETA(3)=  A0 
      DNDETA(4)= -B0
      DNDETA(5)= 0.0
      DNDETA(6)=  B0
c <dN/dZETA>     
      DNDZETA(1)= -RD / 2.0
      DNDZETA(2)= -XI / 2.0
      DNDZETA(3)= -ETA/ 2.0
      DNDZETA(4)=  RD / 2.0 
      DNDZETA(5)=  XI / 2.0
      DNDZETA(6)=  ETA/ 2.0
C
      ELSE
ccc 6-mentai(liner element 8nodes)
      IF(NIE.EQ.8) THEN
      A1 = 1.0 + XI
      B1 = 1.0 + ETA
      C1 = 1.0 + ZETA
      A2 = 1.0 - XI
      B2 = 1.0 - ETA
      C2 = 1.0 - ZETA
      DD = 1.0/8.0
c <N>     
      N(1)= A2 * B2 * C2 * DD
      N(2)= A1 * B2 * C2 * DD
      N(3)= A1 * B1 * C2 * DD
      N(4)= A2 * B1 * C2 * DD
      N(5)= A2 * B2 * C1 * DD
      N(6)= A1 * B2 * C1 * DD
      N(7)= A1 * B1 * C1 * DD
      N(8)= A2 * B1 * C1 * DD
c <dN/dXI>     
      DNDXI(1)= -B2 * C2 * DD 
      DNDXI(2)=  B2 * C2 * DD
      DNDXI(3)=  B1 * C2 * DD
      DNDXI(4)= -B1 * C2 * DD
      DNDXI(5)= -B2 * C1 * DD
      DNDXI(6)=  B2 * C1 * DD
      DNDXI(7)=  B1 * C1 * DD
      DNDXI(8)= -B1 * C1 * DD
c <dN/dETA>
      DNDETA(1)= -A2 * C2 * DD
      DNDETA(2)= -A1 * C2 * DD
      DNDETA(3)=  A1 * C2 * DD
      DNDETA(4)=  A2 * C2 * DD
      DNDETA(5)= -A2 * C1 * DD
      DNDETA(6)= -A1 * C1 * DD
      DNDETA(7)=  A1 * C1 * DD
      DNDETA(8)=  A2 * C1 * DD
c <dN/dZETA>
      DNDZETA(1)= -A2 * B2 * DD
      DNDZETA(2)= -A1 * B2 * DD
      DNDZETA(3)= -A1 * B1 * DD
      DNDZETA(4)= -A2 * B1 * DD
      DNDZETA(5)=  A2 * B2 * DD
      DNDZETA(6)=  A1 * B2 * DD
      DNDZETA(7)=  A1 * B1 * DD
      DNDZETA(8)=  A2 * B1 * DD
c
ccc 6-mentai(liner element 8nodes)--> infinite element
      NKK = NKIND(IE)
      IF(NKK.EQ.1) THEN
c
      BI1 = 1.0 + ETA
      CI1 = 1.0 + ZETA
      BI2 = 1.0 - ETA
      CI2 = 1.0 - ZETA
      XINV = 1.0/(1.0-XI)
      AI1  =   1.0 + 2.0  * XI   *XINV
      AI2  = - 2.0 * XI   * XINV
      DAI1 =   2.0 * XINV * XINV
      DAI2 = - 2.0 * XINV * XINV
      DDI  = 1.0/4.0
c <N>     
      NIF(1)= AI2 * BI2 * CI2 * DDI
      NIF(2)= AI1 * BI2 * CI2 * DDI
      NIF(3)= AI1 * BI1 * CI2 * DDI
      NIF(4)= AI2 * BI1 * CI2 * DDI
      NIF(5)= AI2 * BI2 * CI1 * DDI
      NIF(6)= AI1 * BI2 * CI1 * DDI
      NIF(7)= AI1 * BI1 * CI1 * DDI
      NIF(8)= AI2 * BI1 * CI1 * DDI
c <dN/dXI>     
      DXIF(1)= DAI2 * BI2 * CI2 * DDI
      DXIF(2)= DAI1 * BI2 * CI2 * DDI
      DXIF(3)= DAI1 * BI1 * CI2 * DDI
      DXIF(4)= DAI2 * BI1 * CI2 * DDI
      DXIF(5)= DAI2 * BI2 * CI1 * DDI
      DXIF(6)= DAI1 * BI2 * CI1 * DDI
      DXIF(7)= DAI1 * BI1 * CI1 * DDI
      DXIF(8)= DAI2 * BI1 * CI1 * DDI
c <dN/dETA>
      DETIF(1)= -AI2 * CI2 * DDI
      DETIF(2)= -AI1 * CI2 * DDI
      DETIF(3)=  AI1 * CI2 * DDI
      DETIF(4)=  AI2 * CI2 * DDI
      DETIF(5)= -AI2 * CI1 * DDI
      DETIF(6)= -AI1 * CI1 * DDI
      DETIF(7)=  AI1 * CI1 * DDI
      DETIF(8)=  AI2 * CI1 * DDI
c <dN/dZETA>
      DZEIF(1)= -AI2 * BI2 * DDI
      DZEIF(2)= -AI1 * BI2 * DDI
      DZEIF(3)= -AI1 * BI1 * DDI
      DZEIF(4)= -AI2 * BI1 * DDI
      DZEIF(5)=  AI2 * BI2 * DDI
      DZEIF(6)=  AI1 * BI2 * DDI
      DZEIF(7)=  AI1 * BI1 * DDI
      DZEIF(8)=  AI2 * BI1 * DDI
c
      ENDIF
      ELSE
c
      IF(NIE.EQ.20) THEN
c <N> 
cccc corner cord.
c  N(*) =(1.0?XI)*(1.0??ETA)*(1.0???ZETA)*(-2.0?XI??ETA???ZETA)/8.0
c
      N(1) =(1.0-XI)*(1.0-ETA)*(1.0-ZETA)*(-2.0-XI-ETA-ZETA)/8.0
      N(2) =(1.0+XI)*(1.0-ETA)*(1.0-ZETA)*(-2.0+XI-ETA-ZETA)/8.0
      N(3) =(1.0+XI)*(1.0+ETA)*(1.0-ZETA)*(-2.0+XI+ETA-ZETA)/8.0
      N(4) =(1.0-XI)*(1.0+ETA)*(1.0-ZETA)*(-2.0-XI+ETA-ZETA)/8.0
      N(5) =(1.0-XI)*(1.0-ETA)*(1.0+ZETA)*(-2.0-XI-ETA+ZETA)/8.0
      N(6) =(1.0+XI)*(1.0-ETA)*(1.0+ZETA)*(-2.0+XI-ETA+ZETA)/8.0
      N(7) =(1.0+XI)*(1.0+ETA)*(1.0+ZETA)*(-2.0+XI+ETA+ZETA)/8.0
      N(8) =(1.0-XI)*(1.0+ETA)*(1.0+ZETA)*(-2.0-XI+ETA+ZETA)/8.0
cccc  middle-point XI
c  N(*) =(1.0-XI*XI)(1.0?ETA)(1.0??ZETA)/4.0
      N(9) =(1.0-XI*XI)*(1.0-ETA)*(1.0-ZETA)/4.0
      N(11) =(1.0-XI*XI)*(1.0+ETA)*(1.0-ZETA)/4.0
      N(13)=(1.0-XI*XI)*(1.0-ETA)*(1.0+ZETA)/4.0
      N(15)=(1.0-XI*XI)*(1.0+ETA)*(1.0+ZETA)/4.0
cccc  middle-point ETA
c  N(*) =(1.0?XI)(1.0-ETA*ETA)(1.0??ZETA)/4.0
      N(10) =(1.0+XI)*(1.0-ETA*ETA)*(1.0-ZETA)/4.0
      N(12) =(1.0-XI)*(1.0-ETA*ETA)*(1.0-ZETA)/4.0
      N(14)=(1.0+XI)*(1.0-ETA*ETA)*(1.0+ZETA)/4.0
      N(16)=(1.0-XI)*(1.0-ETA*ETA)*(1.0+ZETA)/4.0
cccc  middle-point ZETA
c  N(*) =(1.0?XI)(1.0??ETA)(1.0-ZETA*ZETA)/4.0
      N(17)=(1.0-XI)*(1.0-ETA)*(1.0-ZETA*ZETA)/4.0
      N(18)=(1.0+XI)*(1.0-ETA)*(1.0-ZETA*ZETA)/4.0
      N(19)=(1.0+XI)*(1.0+ETA)*(1.0-ZETA*ZETA)/4.0
      N(20)=(1.0-XI)*(1.0+ETA)*(1.0-ZETA*ZETA)/4.0
c
c <dN/dXI>     
cccc corner cord.
c  DNDXI(*) = ?(1.0??ETA)*(1.0???ZETA)*(-1.0?2.0*XI??ETA???ZETA)/8.0
      DNDXI(1) = -(1.0-ETA)*(1.0-ZETA)*(-1.0-2.0*XI-ETA-ZETA)/8.0
      DNDXI(2) =  (1.0-ETA)*(1.0-ZETA)*(-1.0+2.0*XI-ETA-ZETA)/8.0
      DNDXI(3) =  (1.0+ETA)*(1.0-ZETA)*(-1.0+2.0*XI+ETA-ZETA)/8.0
      DNDXI(4) = -(1.0+ETA)*(1.0-ZETA)*(-1.0-2.0*XI+ETA-ZETA)/8.0
      DNDXI(5) = -(1.0-ETA)*(1.0+ZETA)*(-1.0-2.0*XI-ETA+ZETA)/8.0
      DNDXI(6) =  (1.0-ETA)*(1.0+ZETA)*(-1.0+2.0*XI-ETA+ZETA)/8.0
      DNDXI(7) =  (1.0+ETA)*(1.0+ZETA)*(-1.0+2.0*XI+ETA+ZETA)/8.0
      DNDXI(8) = -(1.0+ETA)*(1.0+ZETA)*(-1.0-2.0*XI+ETA+ZETA)/8.0
cccc  middle-point XI
c  DNDXI(*) = -XI(1.0?ETA)(1.0??ZETA)/2.0
      DNDXI(9) =-XI*(1.0-ETA)*(1.0-ZETA)/2.0
      DNDXI(11)=-XI*(1.0+ETA)*(1.0-ZETA)/2.0
      DNDXI(13)=-XI*(1.0-ETA)*(1.0+ZETA)/2.0
      DNDXI(15)=-XI*(1.0+ETA)*(1.0+ZETA)/2.0
cccc  middle-point ETA
c  DNDXI(*) =?XI(1.0-ETA*ETA)(1.0??ZETA)/4.0
      DNDXI(10)= (1.0-ETA*ETA)*(1.0-ZETA)/4.0
      DNDXI(12)=-(1.0-ETA*ETA)*(1.0-ZETA)/4.0
      DNDXI(14)= (1.0-ETA*ETA)*(1.0+ZETA)/4.0
      DNDXI(16)=-(1.0-ETA*ETA)*(1.0+ZETA)/4.0
cccc  middle-point ZETA
c  DNDXI(*) =?XI(1.0??ETA)(1.0-ZETA*ZETA)/4.0
      DNDXI(17) =-(1.0-ETA)*(1.0-ZETA*ZETA)/4.0
      DNDXI(18)= (1.0-ETA)*(1.0-ZETA*ZETA)/4.0
      DNDXI(19)= (1.0+ETA)*(1.0-ZETA*ZETA)/4.0
      DNDXI(20)=-(1.0+ETA)*(1.0-ZETA*ZETA)/4.0
c 
c <dN/dETA>    
cccc corner cord.
      DNDETA(1) = -(1.0-XI)*(1.0-ZETA)*(-1.0-XI-2.0*ETA-ZETA)/8.0
      DNDETA(2) = -(1.0+XI)*(1.0-ZETA)*(-1.0+XI-2.0*ETA-ZETA)/8.0
      DNDETA(3) =  (1.0+XI)*(1.0-ZETA)*(-1.0+XI+2.0*ETA-ZETA)/8.0
      DNDETA(4) =  (1.0-XI)*(1.0-ZETA)*(-1.0-XI+2.0*ETA-ZETA)/8.0
      DNDETA(5) = -(1.0-XI)*(1.0+ZETA)*(-1.0-XI-2.0*ETA+ZETA)/8.0
      DNDETA(6) = -(1.0+XI)*(1.0+ZETA)*(-1.0+XI-2.0*ETA+ZETA)/8.0
      DNDETA(7) =  (1.0+XI)*(1.0+ZETA)*(-1.0+XI+2.0*ETA+ZETA)/8.0
      DNDETA(8) =  (1.0-XI)*(1.0+ZETA)*(-1.0-XI+2.0*ETA+ZETA)/8.0
cccc  middle-point XI
c  DNDETA(*) =-?ETA(1.0-XI*XI)(1.0??ZETA)/4.0
      DNDETA(9) =-(1.0-XI*XI)*(1.0-ZETA)/4.0
      DNDETA(11)= (1.0-XI*XI)*(1.0-ZETA)/4.0
      DNDETA(13)=-(1.0-XI*XI)*(1.0+ZETA)/4.0
      DNDETA(15)= (1.0-XI*XI)*(1.0+ZETA)/4.0
cccc  middle-point ETA
c  DNDETA(*) =-ETA(1.0?XI)(1.0??ZETA)/2.0
      DNDETA(10) =-ETA*(1.0+XI)*(1.0-ZETA)/2.0
      DNDETA(12) =-ETA*(1.0-XI)*(1.0-ZETA)/2.0
      DNDETA(14)=-ETA*(1.0+XI)*(1.0+ZETA)/2.0
      DNDETA(16)=-ETA*(1.0-XI)*(1.0+ZETA)/2.0
cccc  middle-point ZETA
c  DNDETA(*) =??ETA(1.0?XI)(1.0-ZETA*ZETA)/4.0
      DNDETA(17) =-(1.0-XI)*(1.0-ZETA*ZETA)/4.0
      DNDETA(18)=-(1.0+XI)*(1.0-ZETA*ZETA)/4.0
      DNDETA(19)= (1.0+XI)*(1.0-ZETA*ZETA)/4.0
      DNDETA(20)= (1.0-XI)*(1.0-ZETA*ZETA)/4.0
c
c <dN/dZETA>     
cccc corner cord.
      DNDZETA(1) = -(1.0-XI)*(1.0-ETA)*(-1.0-XI-ETA-2.0*ZETA)/8.0
      DNDZETA(2) = -(1.0+XI)*(1.0-ETA)*(-1.0+XI-ETA-2.0*ZETA)/8.0
      DNDZETA(3) = -(1.0+XI)*(1.0+ETA)*(-1.0+XI+ETA-2.0*ZETA)/8.0
      DNDZETA(4) = -(1.0-XI)*(1.0+ETA)*(-1.0-XI+ETA-2.0*ZETA)/8.0
      DNDZETA(5) = +(1.0-XI)*(1.0-ETA)*(-1.0-XI-ETA+2.0*ZETA)/8.0
      DNDZETA(6) = +(1.0+XI)*(1.0-ETA)*(-1.0+XI-ETA+2.0*ZETA)/8.0
      DNDZETA(7) = +(1.0+XI)*(1.0+ETA)*(-1.0+XI+ETA+2.0*ZETA)/8.0
      DNDZETA(8) = +(1.0-XI)*(1.0+ETA)*(-1.0-XI+ETA+2.0*ZETA)/8.0
cccc  middle-point XI
c  DNDZETA(*) =-?ZETA(1.0-XI*XI)(1.0??ETA)/4.0
      DNDZETA(9) =-(1.0-XI*XI)*(1.0-ETA)/4.0
      DNDZETA(11)=-(1.0-XI*XI)*(1.0+ETA)/4.0
      DNDZETA(13)=+(1.0-XI*XI)*(1.0-ETA)/4.0
      DNDZETA(15)=+(1.0-XI*XI)*(1.0+ETA)/4.0
cccc  middle-point ETA
c  DNDZETA(*) =?ZETA(1.0??XI)(1.0-ETA*ETA)/4.0
      DNDZETA(10) =-(1.0+XI)*(1.0-ETA*ETA)/4.0
      DNDZETA(12) =-(1.0-XI)*(1.0-ETA*ETA)/4.0
      DNDZETA(14)= (1.0+XI)*(1.0-ETA*ETA)/4.0
      DNDZETA(16)= (1.0-XI)*(1.0-ETA*ETA)/4.0
cccc  middle-point ZETA
c  DNDZETA(*) =-ZETA(1.0?XI)(1.0??ETA)/2.0
      DNDZETA(17) =-ZETA*(1.0-XI)*(1.0-ETA)/2.0
      DNDZETA(18)=-ZETA*(1.0+XI)*(1.0-ETA)/2.0
      DNDZETA(19)=-ZETA*(1.0+XI)*(1.0+ETA)/2.0
      DNDZETA(20)=-ZETA*(1.0-XI)*(1.0+ETA)/2.0
c
      ELSE
C
      IF(NIE.EQ.15) THEN
      RM  = 1.0 - XI - ETA
      RZ1 = -ZETA*(1.0-ZETA)/2.0
      RZ2 =  ZETA*(1.0+ZETA)/2.0
c <N> 
cccc 
      N(1) = -RM*(1.0-2.0*RM)*RZ1
      N(7) = 4.0*XI*RM*RZ1
      N(2) = -XI*(1.0-2.0*XI)*RZ1
      N(8) = 4.0*XI*ETA*RZ1
      N(3) = -ETA*(1.0-2.0*ETA)*RZ1
      N(9) = 4.0*ETA*RM*RZ1
      N(13)= RM*(1.0-ZETA*ZETA)
      N(14)= XI*(1.0-ZETA*ZETA)
      N(15)= ETA*(1.0-ZETA*ZETA)
      N(4) = -RM*(1.0-2.0*RM)*RZ2
      N(10)= 4.0*XI*RM*RZ2
      N(5) = -XI*(1.0-2.0*XI)*RZ2
      N(11)= 4.0*XI*ETA*RZ2
      N(6) = -ETA*(1.0-2.0*ETA)*RZ2
      N(12)= 4.0*ETA*RM*RZ2
c
c <dN/dXI>     
      DNDXI(1) = ( 1.0-4.0*RM)*RZ1
      DNDXI(7) =  4.0*(RM-XI)*RZ1
      DNDXI(2) = (-1.0+4.0*XI)*RZ1
      DNDXI(8) =  4.0*ETA*RZ1
      DNDXI(3) =  0.0
      DNDXI(9) = -4.0*ETA*RZ1
      DNDXI(13)= -(1.0-ZETA*ZETA)
      DNDXI(14)= ( 1.0-ZETA*ZETA)
      DNDXI(15)=  0.0
      DNDXI(4) = ( 1.0-4.0*RM)*RZ2
      DNDXI(10)=  4.0*(RM-XI)*RZ2
      DNDXI(5) = (-1.0+4.0*XI)*RZ2
      DNDXI(11)=  4.0*ETA*RZ2
      DNDXI(6) =  0.0
      DNDXI(12)= -4.0*ETA*RZ2
c <dN/dETA>    
      DNDETA(1) = ( 1.0-4.0*RM)*RZ1
      DNDETA(7) = -4.0*XI*RZ1
      DNDETA(2) =  0.0
      DNDETA(8) =  4.0*XI*RZ1
      DNDETA(3) = (-1.0+4.0*ETA)*RZ1
      DNDETA(9) =  4.0*(RM-ETA)*RZ1
      DNDETA(13)= -(1.0-ZETA*ZETA)
      DNDETA(14)=  0.0
      DNDETA(15)=  (1.0-ZETA*ZETA)
      DNDETA(4) = ( 1.0-4.0*RM)*RZ2
      DNDETA(10)= -4.0*XI*RZ2
      DNDETA(5) =  0.0
      DNDETA(11)=  4.0*XI*RZ2
      DNDETA(6) = (-1.0+4.0*ETA)*RZ2
      DNDETA(12)=  4.0*(RM-ETA)*RZ2

c <dN/dZETA>
      DRZ1 = -(1.0-2.0*ZETA)/2.0
      DRZ2 =  (1.0+2.0*ZETA)/2.0
      DNDZETA(1) = -RM*(1.0-2.0*RM)*DRZ1
      DNDZETA(7) = 4.0*XI*RM*DRZ1
      DNDZETA(2) = -XI*(1.0-2.0*XI)*DRZ1
      DNDZETA(8) = 4.0*XI*ETA*DRZ1
      DNDZETA(3) = -ETA*(1.0-2.0*ETA)*DRZ1
      DNDZETA(9) = 4.0*ETA*RM*DRZ1
      DNDZETA(13)= -2.0*RM*ZETA
      DNDZETA(14)= -2.0*XI*ZETA
      DNDZETA(15)= -2.0*ETA*ZETA
      DNDZETA(4) = -RM*(1.0-2.0*RM)*DRZ2
      DNDZETA(10)= 4.0*XI*RM*DRZ2
      DNDZETA(5) = -XI*(1.0-2.0*XI)*DRZ2
      DNDZETA(11)= 4.0*XI*ETA*DRZ2
      DNDZETA(6) = -ETA*(1.0-2.0*ETA)*DRZ2
      DNDZETA(12)= 4.0*ETA*RM*DRZ2
c
      ENDIF
      ENDIF
      ENDIF
      ENDIF
c      
      RETURN
      END
