C     GAUSS-LEGENDRE PROGRAM
      SUBROUTINE newton_cotes(AXI,AETA,AZETA,H,NMTE)
      INCLUDE 'para.inc'
      INCLUDE 'const.inc'
      DIMENSION AXI(*),AETA(*),AZETA(*),H(*),NMTE(*)

C  6MENTAI-8NODE NO SEKIBUN
C  2ND-ORDER , INTEGRATION 
      IF((NMTE(IE).EQ.8).AND.(NGAUSS.EQ.2))THEN
C
      A_1=1.0d0
      DO 50 I=1,8
      H(I)=1.0d0
  50  CONTINUE
C   
      AXI(1)  =-A_1
      AETA(1) =-A_1
      AZETA(1)=-A_1
      AXI(2)  = A_1
      AETA(2) =-A_1
      AZETA(2)=-A_1
      AXI(3)  =-A_1
      AETA(3) = A_1
      AZETA(3)=-A_1
      AXI(4)  = A_1
      AETA(4) = A_1
      AZETA(4)=-A_1
C
      DO 111 I8 = 1,4
       AXI(4+I8)  =  AXI(I8)
       AETA(4+I8) =  AETA(I8)
       AZETA(4+I8)= -AZETA(I8)
 111  CONTINUE
C
      else
      stop '8node 2nd integration only'         
      endif
C
      RETURN
      END
