cc constant
c--------------------------------------------------------------
c FOR SUBROUTIE DATA
c  NGAUSS : Order of GAUSS integration
c  NPARA  : Analysis condition (0:plain stress,1:plain strain)
cccc  T      : Thickness
c  NTN    : total number of nodes
c  NTE    : total number of elements
c  NTF    : total number of freedoms
cccc  IE     : element number(variables)
c  NTFOR  : total number of freedoms with initial load
c  NTDIS  : total number of freedoms with initial displacement
c  NNA    : The total number of integration points
c  MNUM   : number of the kind of material
c  NB     : half band width
c--------------------------------------------------------------
	COMMON /CON1/ NGAUSS,NPARA,NTN,NTE,NTF,NNA,MNUM
	COMMON /CON2/ NTFOR,NTDIS,NB
	COMMON /CON3/ IE
c
cccc FOR EQUATION
c  NAEQ : NUMBER OF EQUATION
c     NEQB : ROOT FREEDOM
c     NTEQ : NUMBER OF COPY FREEDOM
c     NEQ  : COPY FREEDOM
	COMMON /EQ0/ NAEQ
	COMMON /EQ1/ NEQB(5),NTEQ(5)
	COMMON /EQ2/ NEQ(5,100)
