      SUBROUTINE SBSUB(A,N,NUD,N1,B,DR,Z)
      INCLUDE 'para.inc'      
c      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION A(N1,N), B(N), DR(N), Z(N)
C  FORWARD SUBSTITUTION
      M = NUD + 1
      IF (M .LT. 3) THEN
       Z(1) = B(1)
       DO 40 J=2,N
  40    Z(J) = B(J) - A(1,J) * Z(J-1)
       DO 50 J=1,N
  50    Z(J) = Z(J) * DR(J)
       B(N) = Z(N)
       DO 60 J=1,N-1
  60    B(N-J) = Z(N-J) - A(1,N-J+1) * B(N-J+1)
      ELSE
       Z(1) = B(1)
       Z(2) = B(2) - A(M-1,2) * Z(1)
       DO 80 J=3,N
        IF (J .GT. M) THEN
         I1 = 1
        ELSE
         I1 = M - J + 1
        ENDIF
        SUM = 0.0D0
        DO 70 K=I1,M-1
 70      SUM = SUM + A(K,J) * Z(J-M+K)
 80     Z(J) = B(J) - SUM
       DO 90 J=1,N
 90     Z(J) = Z(J) * DR(J)
C
       B(N) = Z(N)
       B(N-1) = Z(N-1) - A(M-1,N) * Z(N)
       DO 110 J=3,N
        J1 = N - J + 1
        I1 = 1
        IF (J .LT. M) I1 = M - J + 1
        SUM = 0.0D0
        DO 100 K=I1,M-1
 100     SUM = SUM + A(K,M-K+J1) * B(M-K+J1)
        B(J1) = Z(J1) - SUM
 110  CONTINUE
      ENDIF
C
      RETURN
      END
